#!/usr/bin/python								
# AHMED ALMOHSIN
# PEOPLE GENERATOR - SYSTEMS PROGRAMMING
# ERIC BROWN
# IMPORT NEEDED SUPPORT MODULES
from urllib2 import *
import sys
import optparse	
import random

parser = optparse.OptionParser() #INSTANTIATE THE PARSER
(opts,args)=parser.parse_args()	 #LINE THAT ACTUALLY PARSES OUR OPTIONS

#FUNCTIONS FOR EACH PART OF THE PERSON'S INFORMATION
def first_name():
	if random.randrange(0,1) == 0:
		# CREATE MALE NAME
		nameRandom = random.randrange(0, len(nameList))
		fullName = nameList[nameRandom].strip() + " "
	else:
		# CREATE FEMALE NAME
		nameRandom = random.randrange(0, len(fnameList))
		fullName = fnameList[nameRandom].strip() + " "
	loop = 0
	timesToLoop = random.randrange(0, 4)
	while (loop < timesToLoop):
		nameRandom = random.randrange(0, len(nameList))
		fullName += nameList[nameRandom].strip() + " "
		loop = loop + 1
		

	return  fullName # GET THE PERSON'S FULL NAME

def id():
	uniqueID = "T" + str(random.randint(100000000, 999999999)) # CREATING THE USER ID NUMBER
	return  uniqueID # GET THE PERSON'S ID NUMBER

	
def last_name():

	return lastNameList[random.randrange(0, len(lastNameList))].strip() # GET A RANDOM LAST NAME FROM THE LAST NAME LIST
	
def dept_name():
	# DEPARTMENT LIST
	deptName = ('Archaeology', 'Arts', 'Biology', 'Biomedical Sciences', 'Biosciences', 'Business School', 'Chemistry', 'Civil Engineering', 'Computer Science', 		'Economics', 'Education', 'Engineering', 'English Studies', 'Genetics', 'Geography', 'German Studies' , 'History', 'Humanities', 'Law', 'Mathematical 		Sciences', 'Medicine & Health', 'Sciences', 'Music', 'Nursing', 'Psychology')
	
	deptRandom = random.randrange(0, 25)
	return deptName[deptRandom] # GET A RANDOM DEPARTMENT

# THIS FUNCTION WILL CREATE A RANDOM HOME PHONE NUMBER
def home_number():
		
	hphoneDigits = (random.randrange(3, 10),random.randrange(0, 10),random.randrange(0, 10),random.randrange(2, 10),random.randrange(0, 10),random.randrange(0, 10),random.randrange(0, 10),random.randrange(0, 10),random.randrange(0, 10),random.randrange(0, 10))
	
	return '(' + str(hphoneDigits[0]) + str(hphoneDigits[1]) + str(hphoneDigits[2]) + ')' + str(hphoneDigits[3]) + str(hphoneDigits[4]) + str(hphoneDigits[5]) + '-' + str(hphoneDigits[6]) + str(hphoneDigits[7]) + str(hphoneDigits[8]) + str(hphoneDigits[9])

# THIS FUNCTION WILL CREATE A RANDOM OFFICE PHONE NUMBER
def office_number():
		
	hphoneDigits = (random.randrange(3, 10),random.randrange(0, 10),random.randrange(0, 10),random.randrange(2, 10),random.randrange(0, 10),random.randrange(0, 10),random.randrange(0, 10),random.randrange(0, 10),random.randrange(0, 10),random.randrange(0, 10))
	
	return '(' + str(hphoneDigits[0]) + str(hphoneDigits[1]) + str(hphoneDigits[2]) + ')'  + str(hphoneDigits[3]) + str(hphoneDigits[4]) + str(hphoneDigits[5]) + '-' + str(hphoneDigits[6]) + str(hphoneDigits[7]) + str(hphoneDigits[8]) + str(hphoneDigits[9])

# THIS FUNCTION WILL CREATE A RANDOM MOBILE PHONE NUMBER
def mobile_number():
		
	hphoneDigits = (random.randrange(3, 10),random.randrange(0, 10),random.randrange(0, 10),random.randrange(2, 10),random.randrange(0, 10),random.randrange(0, 10),random.randrange(0, 10),random.randrange(0, 10),random.randrange(0, 10),random.randrange(0, 10))
	
	return '(' + str(hphoneDigits[0]) + str(hphoneDigits[1]) + str(hphoneDigits[2]) + ')'  + str(hphoneDigits[3]) + str(hphoneDigits[4]) + str(hphoneDigits[5]) + '-' + str(hphoneDigits[6]) + str(hphoneDigits[7]) + str(hphoneDigits[8]) + str(hphoneDigits[9])

# THIS FUNCTION WILL CREATE A TECH EMAIL ADDRESS AND WILL USE THE LAST NAME AS AN ID
def work_email():
	userList = ('A','B','C','D','E','F','G','H','I','J','K','L','M','N','O','P','Q','R','S','T','U','V','W','X','Y','Z')
	return userList[random.randrange(0, 25)] + userList[random.randrange(0, 25)] + testLastName + str(random.randint(10, 99)) + "@TNTECH.EDU"
		
def complete_info():
		
	global testLastName	# THIS GLOBAL VARIABLE IS USED BY THE work_email FUNCTION TO GENERATE A SUITABLE EMAIL ADDRESS
	testLastName = last_name()
	
	return id() + " ," + first_name() + testLastName + " ," + dept_name()  + " ," + home_number() + " ," + office_number() + " ," + mobile_number() + " ," + work_email()

# ================================= MAIN PROGRAM ================================= 

def main():	
	# SETS THE BEHAVIOR OF THE PROGRAM DEPENDING ON THE NUMBER OF ARGUMENTS PASSED	
	if (len(sys.argv)) == 1:
		timesToLoop = 1 # DEFAULT NUMBER OF PPL
	elif (len(sys.argv)) == 2:
		timesToLoop = int(sys.argv[1]) # NUMBER OF PPL DEFINED BY THE USER		

	# OPEN THE LAST NAMES FILE FROM THE URL
	ur = urlopen("http://www.census.gov/genealogy/names/dist.all.last")
	contents = ur.readlines() # READLINES FROM THE URL FILE
	global lastNameList
	lastNameList = []	  # CREATE AN EMPTY LIST
	for row in contents:
		name\
		= row.strip().split(' ')
		lastNameList.append(name[0])

	# OPEN THE MALE NAMES FILE FROM THE URL
	ur = urlopen("http://www.census.gov/genealogy/names/dist.male.first")
	contents = ur.readlines() # READLINES FROM THE URL FILE
	global nameList
	nameList = []		  # CREATE AN EMPTY LIST
	for row in contents:
		name\
		= row.strip().split(' ')
		nameList.append(name[0])

	# OPEN THE FEMALE NAMES FILE FROM THE URL
	ur = urlopen("http://www.census.gov/genealogy/names/dist.female.first")
	contents = ur.readlines() # READLINES FROM THE URL FILE
	global fnameList
	fnameList = []		  # CREATE AN EMPTY LIST
	for row in contents:
		name\
		= row.strip().split(' ')
		fnameList.append(name[0])
		
	loop = 0
	s = open("output.csv","w")
	while (loop < timesToLoop): # SETS THE TIMES THE LOOP WILL RUN. DEFAULT IS 1 IF NOT SPECIFIED BY USER
		s.write(complete_info() + "\n")
		loop = loop + 1
	s.close()
		
# ================================= END MAIN PROGRAM ================================= 

# CALLING THE MAIN MODULE
if __name__=="__main__":
	main()	
