#!/usr/bin/python
from socket import *
import struct,time

time_server = ('time.tntech.edu', 123)

TIME1970 = 2208988800L  

client = socket( AF_INET, SOCK_DGRAM )
data = '\x1b' + 47 * '\0'
client.sendto(data, time_server)
data, address = client.recvfrom( 1024 )
if data:
    print 'Response received from', address,'\n'
    t = struct.unpack( '!12I', data )[10]
    if t == 0:
        raise 'invalid response'
    ct = time.ctime(t - TIME1970)
    print 'Current time = %s\n' % ct
else:
    raise 'no data returned'
