#!/usr/bin/env python
# Name: Timothy Myers
# A very simple SNTP client
# Source from: Firat Atagun
# http://www.firatatagun.com/python-ntp-client/2009/12/
from socket import *
import struct,time,sys
 

time_server = ('time.tntech.edu', 123)
 
# unix epoch needed because we give
# the ntp server a base time of 0
epoch = 2208988800L
 
# opens socket
client = socket( AF_INET, SOCK_DGRAM )
 
# set version to 3 and mode to 4
data = '\x1b' + 47 * '\0'
 
client.sendto(data, time_server)
 
data, address = client.recvfrom( 1024 )
 
if data:
    print 'NTP server', address,'\n'
 
   #grab the eleventh 4 byte unigned integer 
    time_now = struct.unpack( '!12I', data )[10]
 
    if time_now == 0:
        raise 'invalid response'
 
    # get the current time with the results given
    tim = time.ctime(time_now - epoch)
 
    print 'Time now = %s\n' % tim
 
else:
    raise 'no data returned'
