#!/usr/bin/env ruby
# Name: Timothy Myers
# A very simple SNTP client
require 'socket'
include Socket::Constants

hostname = 'time.tntech.edu'
port = 123

#Open the socket for the ntp server
s = UDPSocket.open()
s.connect(hostname, port)

#We need the epoch again
epoch = 2208988800

#Again 3 for version and 4 for mode
data = "\x1b" +  "\0" * 47

#Send and get back response
s.send(data,0)
data  = s.recvfrom(1024)
if data

   print 'NTP server ', data[1][3], "\n"

   #Get time back
   time_packet = data[0].unpack('N12')
   time_now = time_packet[10]
   #Correct from epoch
   time_now -= epoch

   print "Time now = %s\n" % Time.at(time_now).strftime("%Y-%m-%d %H:%M:%S")

else
	print "Incorrect return\n"

end
s.close


