#!/usr/bin/ruby
# Ahmed Almohsin
# CSC3550 Eric Brown
# here is a list of server that work:
# http://tycho.usno.navy.mil/ntp.html 

require 'optparse'
require 'socket'

SNTP_MSG = "\010" + "\0" * 47
SNTP_PORT = 123
NTP_UNIX_TIME = 2208988800

set_time = false

unless ARGV[0]
  puts opts
  exit
end

data = UDPSocket.open do |sd|
  sd.send(SNTP_MSG, 0, ARGV[0], SNTP_PORT)
  sd.recvfrom(64)[0]
end

data = data.unpack('N12')[10].to_i - NTP_UNIX_TIME
time = Time.at(data)
